/*
 * SPDX-License-Identifier: Apache-2.0
 */

#ifndef _ST7735_DISPLAY_DRIVER_H_
#define _ST7735_DISPLAY_DRIVER_H_

#include <zephyr.h>

#define ST7735_DISPLAY_NOP 0x00
#define ST7735_DISPLAY_SWRESET 0x01
#define ST7735_DISPLAY_RDDID 0x04
#define ST7735_DISPLAY_RDDST 0x09

#define ST7735_DISPLAY_SLPIN 0x10
#define ST7735_DISPLAY_SLPOUT 0x11
#define ST7735_DISPLAY_PTLON 0x12
#define ST7735_DISPLAY_NORON 0x13

#define ST7735_DISPLAY_INVOFF 0x20
#define ST7735_DISPLAY_INVON 0x21
#define ST7735_DISPLAY_DISPOFF 0x28
#define ST7735_DISPLAY_DISPON 0x29
#define ST7735_DISPLAY_CASET 0x2A
#define ST7735_DISPLAY_RASET 0x2B
#define ST7735_DISPLAY_RAMWR 0x2C
#define ST7735_DISPLAY_RAMRD 0x2E

#define ST7735_DISPLAY_PTLAR 0x30
#define ST7735_DISPLAY_COLMOD 0x3A
#define ST7735_DISPLAY_MADCTL 0x36

#define ST7735_DISPLAY_FRMCTR1 0xB1
#define ST7735_DISPLAY_FRMCTR2 0xB2
#define ST7735_DISPLAY_FRMCTR3 0xB3
#define ST7735_DISPLAY_INVCTR 0xB4
#define ST7735_DISPLAY_DISSET5 0xB6

#define ST7735_DISPLAY_PWCTR1 0xC0
#define ST7735_DISPLAY_PWCTR2 0xC1
#define ST7735_DISPLAY_PWCTR3 0xC2
#define ST7735_DISPLAY_PWCTR4 0xC3
#define ST7735_DISPLAY_PWCTR5 0xC4
#define ST7735_DISPLAY_VMCTR1 0xC5

#define ST7735_DISPLAY_RDID1 0xDA
#define ST7735_DISPLAY_RDID2 0xDB
#define ST7735_DISPLAY_RDID3 0xDC
#define ST7735_DISPLAY_RDID4 0xDD

#define ST7735_DISPLAY_PWCTR6 0xFC

#define ST7735_DISPLAY_GMCTRP1 0xE0
#define ST7735_DISPLAY_GMCTRN1 0xE1

#define ST7735_DISPLAY_MADCTL_MY 0x80
#define ST7735_DISPLAY_MADCTL_MX 0x40
#define ST7735_DISPLAY_MADCTL_MV 0x20
#define ST7735_DISPLAY_MADCTL_ML 0x10
#define ST7735_DISPLAY_MADCTL_RGB 0x00
#define ST7735_DISPLAY_MADCTL_BGR 0x08
#define ST7735_DISPLAY_MADCTL_MH 0x04

#define ST7735_DISPLAY_PIXEL_SIZE 2

#endif /* _ST7735_DISPLAY_DRIVER_H_ */
